structure TestTheory :> TestTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open L0Theory
  in end;
  val _ = Theory.link_parents ("Test",51329324,0) [("L0",51329319,0)];
  val _ = Theory.incorporate_types "Test" [("TEST",0)];
  val _ = Theory.incorporate_consts "Test"
     [("dest_TEST",
       ((T"TEST" "Test" [] -->
         T"recspace" "ind_type" [T"INSTR" "L0" []]))),
      ("TEST_case",
       (((T"INSTR" "L0" [] --> alpha) -->
         ((T"TEST" "Test" [] --> alpha) -->
          (T"TEST" "Test" [] --> alpha))))),
      ("mk_TEST",
       ((T"recspace" "ind_type" [T"INSTR" "L0" []] -->
         T"TEST" "Test" []))), ("/::",(((alpha --> alpha) --> alpha))),
      ("TEST_size",((T"TEST" "Test" [] --> T"num" "num" []))),
      ("TEST",((T"INSTR" "L0" [] --> T"TEST" "Test" []))),
      ("whitebox",((T"INSTR" "L0" [] --> T"INSTR" "L0" []))),
      ("Test1",((T"TEST" "Test" [] --> T"TEST" "Test" []))),
      ("Test0",((T"INSTR" "L0" [] --> T"TEST" "Test" []))),
      ("SUITE",((T"TEST" "Test" [] --> T"TEST" "Test" [])))];
  
  local
  val share_table = Vector.fromList
  [C"?" "bool"
    ((((T"TEST" "Test" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []])
       --> bool) --> bool)),
   V"rep"
    ((T"TEST" "Test" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []])),
   C"TYPE_DEFINITION" "bool"
    (((T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool) -->
      ((T"TEST" "Test" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []])
       --> bool))), V"a0" (T"recspace" "ind_type" [T"INSTR" "L0" []]),
   C"!" "bool"
    ((((T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool) --> bool) -->
      bool)),
   V"'TEST'" ((T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool)),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"!" "bool"
    (((T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool) --> bool)),
   C"\\/" "bool" ((bool --> (bool --> bool))),
   C"?" "bool" (((T"INSTR" "L0" [] --> bool) --> bool)),
   V"a" (T"INSTR" "L0" []),
   C"=" "min"
    ((T"recspace" "ind_type" [T"INSTR" "L0" []] -->
      (T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool))),
   C"CONSTR" "ind_type"
    ((T"num" "num" [] -->
      (T"INSTR" "L0" [] -->
       ((T"num" "num" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []]) -->
        T"recspace" "ind_type" [T"INSTR" "L0" []])))),
   C"0" "num" (T"num" "num" []), V"n" (T"num" "num" []),
   C"BOTTOM" "ind_type" (T"recspace" "ind_type" [T"INSTR" "L0" []]),
   C"?" "bool"
    (((T"recspace" "ind_type" [T"INSTR" "L0" []] --> bool) --> bool)),
   V"a" (T"recspace" "ind_type" [T"INSTR" "L0" []]),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"SUC" "num" ((T"num" "num" [] --> T"num" "num" [])),
   C"@" "min" (((T"INSTR" "L0" [] --> bool) --> T"INSTR" "L0" [])),
   V"v" (T"INSTR" "L0" []), C"T" "bool" (bool),
   C"FCONS" "ind_type"
    ((T"recspace" "ind_type" [T"INSTR" "L0" []] -->
      ((T"num" "num" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []]) -->
       (T"num" "num" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []])))),
   C"!" "bool" (((T"TEST" "Test" [] --> bool) --> bool)),
   V"a" (T"TEST" "Test" []),
   C"=" "min" ((T"TEST" "Test" [] --> (T"TEST" "Test" [] --> bool))),
   C"mk_TEST" "Test"
    ((T"recspace" "ind_type" [T"INSTR" "L0" []] --> T"TEST" "Test" [])),
   C"dest_TEST" "Test"
    ((T"TEST" "Test" [] --> T"recspace" "ind_type" [T"INSTR" "L0" []])),
   V"r" (T"recspace" "ind_type" [T"INSTR" "L0" []]),
   C"=" "min" ((bool --> (bool --> bool))),
   C"=" "min"
    (((T"INSTR" "L0" [] --> T"TEST" "Test" []) -->
      ((T"INSTR" "L0" [] --> T"TEST" "Test" []) --> bool))),
   C"Test0" "Test" ((T"INSTR" "L0" [] --> T"TEST" "Test" [])),
   C"=" "min"
    (((T"TEST" "Test" [] --> T"TEST" "Test" []) -->
      ((T"TEST" "Test" [] --> T"TEST" "Test" []) --> bool))),
   C"Test1" "Test" ((T"TEST" "Test" [] --> T"TEST" "Test" [])),
   C"TEST" "Test" ((T"INSTR" "L0" [] --> T"TEST" "Test" [])),
   C"SUITE" "Test" ((T"TEST" "Test" [] --> T"TEST" "Test" [])),
   C"!" "bool" ((((T"INSTR" "L0" [] --> alpha) --> bool) --> bool)),
   V"f" ((T"INSTR" "L0" [] --> alpha)),
   C"!" "bool" ((((T"TEST" "Test" [] --> alpha) --> bool) --> bool)),
   V"f1" ((T"TEST" "Test" [] --> alpha)),
   C"!" "bool" (((T"INSTR" "L0" [] --> bool) --> bool)),
   C"=" "min" ((alpha --> (alpha --> bool))),
   C"TEST_case" "Test"
    (((T"INSTR" "L0" [] --> alpha) -->
      ((T"TEST" "Test" [] --> alpha) --> (T"TEST" "Test" [] --> alpha)))),
   C"=" "min" ((T"num" "num" [] --> (T"num" "num" [] --> bool))),
   C"TEST_size" "Test" ((T"TEST" "Test" [] --> T"num" "num" [])),
   C"NUMERAL" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"NUMERAL_BIT1" "arithmetic" ((T"num" "num" [] --> T"num" "num" [])),
   C"ALT_ZERO" "arithmetic" (T"num" "num" []),
   C"+" "arithmetic"
    ((T"num" "num" [] --> (T"num" "num" [] --> T"num" "num" []))),
   V"a'" (T"INSTR" "L0" []),
   C"=" "min" ((T"INSTR" "L0" [] --> (T"INSTR" "L0" [] --> bool))),
   V"a'" (T"TEST" "Test" []), C"~" "bool" ((bool --> bool)),
   V"M" (T"TEST" "Test" []), V"M'" (T"TEST" "Test" []),
   V"f'" ((T"INSTR" "L0" [] --> alpha)),
   V"f1'" ((T"TEST" "Test" [] --> alpha)), V"T'" (T"TEST" "Test" []),
   V"I'" (T"INSTR" "L0" []),
   C"?" "bool" (((T"TEST" "Test" [] --> bool) --> bool)),
   V"f0" ((T"INSTR" "L0" [] --> alpha)),
   C"!" "bool"
    ((((T"TEST" "Test" [] --> (alpha --> alpha)) --> bool) --> bool)),
   V"f1" ((T"TEST" "Test" [] --> (alpha --> alpha))),
   C"?" "bool" ((((T"TEST" "Test" [] --> alpha) --> bool) --> bool)),
   V"fn" ((T"TEST" "Test" [] --> alpha)),
   C"!" "bool" ((((T"TEST" "Test" [] --> bool) --> bool) --> bool)),
   V"P" ((T"TEST" "Test" [] --> bool))]
  val DT = Thm.disk_thm share_table
  in
  val TEST_TY_DEF =
    DT("", [],
       `(%0 (\%1. ((%2 (\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 ((%8 (%9 (\%10.
       ((%11 $1) ((\%10. (((%12 %13) $0) (\%14. %15))) $0))))) (%16 (\%17.
       ((%18 ((%11 $1) ((\%17. (((%12 (%19 %13)) (%20 (\%21. %22))) ((%23
       $0) (\%14. %15)))) $0))) ($2 $0)))))) ($1 $0))))) ($0 $1))))))
       $0)))`)
  val TEST_repfns =
    DT("", [],
       `((%18 (%24 (\%25. ((%26 (%27 (%28 $0))) $0)))) (%7 (\%29. ((%30
       ((\%3. (%4 (\%5. ((%6 (%7 (\%3. ((%6 ((%8 (%9 (\%10. ((%11 $1)
       ((\%10. (((%12 %13) $0) (\%14. %15))) $0))))) (%16 (\%17. ((%18
       ((%11 $1) ((\%17. (((%12 (%19 %13)) (%20 (\%21. %22))) ((%23 $0)
       (\%14. %15)))) $0))) ($2 $0)))))) ($1 $0))))) ($0 $1))))) $0)) ((%11
       (%28 (%27 $0))) $0)))))`)
  val Test0_def =
    DT("", [],
       `((%31 %32) (\%10. (%27 ((\%10. (((%12 %13) $0) (\%14. %15)))
       $0))))`)
  val Test1_def =
    DT("", [],
       `((%33 %34) (\%25. (%27 ((\%17. (((%12 (%19 %13)) (%20 (\%21. %22)))
       ((%23 $0) (\%14. %15)))) (%28 $0)))))`)
  val TEST = DT("", [], `((%31 %35) %32)`)
  val SUITE = DT("", [], `((%33 %36) %34)`)
  val TEST_case_def =
    DT("", [],
       `((%18 (%37 (\%38. (%39 (\%40. (%41 (\%10. ((%42 (((%43 $2) $1) (%35
       $0))) ($2 $0))))))))) (%37 (\%38. (%39 (\%40. (%24 (\%25. ((%42
       (((%43 $2) $1) (%36 $0))) ($1 $0)))))))))`)
  val TEST_size_def =
    DT("", [],
       `((%18 (%41 (\%10. ((%44 (%45 (%35 $0))) (%46 (%47 %48)))))) (%24
       (\%25. ((%44 (%45 (%36 $0))) ((%49 (%46 (%47 %48))) (%45 $0))))))`)
  val TEST_11 =
    DT("", [],
       `((%18 (%41 (\%10. (%41 (\%50. ((%30 ((%26 (%35 $1)) (%35 $0)))
       ((%51 $1) $0))))))) (%24 (\%25. (%24 (\%52. ((%30 ((%26 (%36 $1))
       (%36 $0))) ((%26 $1) $0)))))))`)
  val TEST_distinct =
    DT("", [],
       `(%24 (\%52. (%41 (\%10. (%53 ((%26 (%35 $0)) (%36 $1)))))))`)
  val TEST_case_cong =
    DT("", [],
       `(%24 (\%54. (%24 (\%55. (%37 (\%38. (%39 (\%40. ((%6 ((%18 ((%26
       $3) $2)) ((%18 (%41 (\%10. ((%6 ((%26 $3) (%35 $0))) ((%42 ($2 $0))
       (%56 $0)))))) (%24 (\%25. ((%6 ((%26 $3) (%36 $0))) ((%42 ($1 $0))
       (%57 $0)))))))) ((%42 (((%43 $1) $0) $3)) (((%43 %56) %57)
       $2)))))))))))`)
  val TEST_nchotomy =
    DT("", [],
       `(%24 (\%58. ((%8 (%9 (\%59. ((%26 $1) (%35 $0))))) (%60 (\%58.
       ((%26 $1) (%36 $0)))))))`)
  val TEST_Axiom =
    DT("", [],
       `(%37 (\%61. (%62 (\%63. (%64 (\%65. ((%18 (%41 (\%10. ((%42 ($1
       (%35 $0))) ($3 $0))))) (%24 (\%25. ((%42 ($1 (%36 $0))) (($2 $0) ($1
       $0))))))))))))`)
  val TEST_induction =
    DT("", [],
       `(%66 (\%67. ((%6 ((%18 (%41 (\%59. ($1 (%35 $0))))) (%24 (\%58.
       ((%6 ($1 $0)) ($1 (%36 $0))))))) (%24 (\%58. ($1 $0))))))`)
  end
  val _ = DB.bindl "Test"
  [("TEST_TY_DEF",TEST_TY_DEF,DB.Def), ("TEST_repfns",TEST_repfns,DB.Def),
   ("Test0_def",Test0_def,DB.Def), ("Test1_def",Test1_def,DB.Def),
   ("TEST",TEST,DB.Def), ("SUITE",SUITE,DB.Def),
   ("TEST_case_def",TEST_case_def,DB.Def),
   ("TEST_size_def",TEST_size_def,DB.Def), ("TEST_11",TEST_11,DB.Thm),
   ("TEST_distinct",TEST_distinct,DB.Thm),
   ("TEST_case_cong",TEST_case_cong,DB.Thm),
   ("TEST_nchotomy",TEST_nchotomy,DB.Thm),
   ("TEST_Axiom",TEST_Axiom,DB.Thm),
   ("TEST_induction",TEST_induction,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("L0Theory.L0_grammars",L0Theory.L0_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms temp_add_type "TEST"
  val _ = update_grms
       (temp_overload_on_by_nametype "mk_TEST")
        {Name = "mk_TEST", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "dest_TEST")
        {Name = "dest_TEST", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Test0")
        {Name = "Test0", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "Test1")
        {Name = "Test1", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "TEST")
        {Name = "TEST", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "SUITE")
        {Name = "SUITE", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "TEST_case")
        {Name = "TEST_case", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "TEST_size")
        {Name = "TEST_size", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "case")
        {Name = "TEST_case", Thy = "Test"}
  val _ = update_grms
       (temp_overload_on_by_nametype "/::")
        {Name = "/::", Thy = "Test"}
  val _ = update_grms temp_add_binder ("/::", std_binder_precedence)
  val _ = update_grms
       (temp_overload_on_by_nametype "whitebox")
        {Name = "whitebox", Thy = "Test"}
  val Test_grammars = Parse.current_lgrms()
  end
  
  
  val _ =
     let open TypeBasePure 
         val tyinfo0 = mk_tyinfo
          {ax=ORIG TEST_Axiom,
           case_def=TEST_case_def,
           case_cong=TEST_case_cong,
           induction=ORIG TEST_induction,
           nchotomy=TEST_nchotomy,
           size=SOME(Parse.Term`(TEST_size) :TEST -> num`,
                     ORIG TEST_size_def),
           boolify = NONE,
  
           one_one=SOME TEST_11,
           distinct=SOME TEST_distinct}
     in
      TypeBase.write  tyinfo0;
      computeLib.write_datatype_info tyinfo0
     end;
  
end
