(* just a dummy structure *)

structure Logic :> Logic =
  struct

  local

   open Parse HolKernel 
   open L0_emb_mldata L0_emb_basic 
   open Logic_Util 
   
   val msg = "Dummy Logic-struct"

   in

   type Lstate   = unit 
   type Loption  = unit

   val wpAlgebra  = 

     { fprint  = (fn _ => raise Fail msg)
     , fasg    = (fn _ => raise Fail msg)
     , fseq    = (fn _ => raise Fail msg)
     , fcall   = (fn _ => raise Fail msg)
     , fif     = (fn _ => raise Fail msg)
     , flocal  = (fn _ => raise Fail msg)
     , fwhile  = (fn _ => raise Fail msg)
     , fassert = (fn _ => raise Fail msg)
     } 

   val option    = ref ()
   val guessInv  = ref (fn _ => raise Fail msg)
   val getSpec   = ref (fn _ => raise Fail msg)
   val state     = ref ()
   val initializeState = (fn _ => raise Fail msg)
   val add_VCs   = (fn _ => raise Fail msg)
   val get_VCs   = (fn _ => raise Fail msg)    
   val isErrorEchoOn = (fn _ => raise Fail msg)            
   end 
end ;