(* =============================================================

   just a dummy signature

============================================================= *)
structure SChecker :> SChecker =
   struct

   local

   open L0_emb_mldata 

   val msg = "Dummy SyntaxChecker-struct"
  
   in

   type SCstate    = unit
   type SCoption   = unit
   type SCmsg    = unit

   val state       = ref ()
   val option      = ref ()

   val initializeState = (fn _ => raise Fail msg)
   val add_SCmsgs      = (fn _ => raise Fail msg)
   val get_SCmsgs      = (fn _ => raise Fail msg)
   val print_SCmsg     = (fn _ => raise Fail msg)
   val L0Error2SCmsg   = (fn _ => raise Fail msg)
   val L0Warning2SCmsg = (fn _ => raise Fail msg)

   val check_expr          = (fn _ => raise Fail msg)
   val check_assertion     = (fn _ => raise Fail msg)
   val check_assertion_ret = (fn _ => raise Fail msg)
   val check_actual_param  = (fn _ => raise Fail msg)
   val check_allowedtype   = (fn _ => raise Fail msg)

   val scAlgebra   =

     { fprint  = (fn _ => raise Fail msg)
     , fasg    = (fn _ => raise Fail msg)
     , fseq    = (fn _ => raise Fail msg)
     , fcall   = (fn _ => raise Fail msg)
     , fif     = (fn _ => raise Fail msg)
     , flocal  = (fn _ => raise Fail msg)
     , fwhile  = (fn _ => raise Fail msg)
     , fassert = (fn _ => raise Fail msg)
     } 

   end 
end 

