(* ===================================================================

  Defining a function XI. XI is a "charasteristic function" that maps
  boolean value to integer 0 and 1.

  author: wishnu prasetya

=================================================================== *)

local

open Parse HolKernel boolLib bossLib intLib ;

in

val _ = new_theory "xi" ;

val XI_def  = Define `XI p = if p then (1:int) else 0` ;

val XI_lemma = store_thm ("XI_lemma",
 --`!p. p = (XI p > 0)`--,
    RW_TAC int_ss [XI_def]) ;

val _ = export_theory();

end ;