structure linguTheory :> linguTheory =
struct
  open Type Term Thm
  infixr -->
  fun C s t ty = mk_thy_const{Name=s,Thy=t,Ty=ty}
  fun T s t A = mk_thy_type{Tyop=s, Thy=t,Args=A}
  fun V s q = mk_var(s,q)
  val U     = mk_vartype
  
  (*  Parents *)
  local open L0Theory pred_setTheory
  in end;
  val _ = Theory.link_parents
          ("lingu",51332510,0)
          [("pred_set",44414703,0), ("L0",51329319,0)];
  val _ = Theory.incorporate_types "lingu" [];
  val _ = Theory.incorporate_consts "lingu"
     [("SOMEof",(((alpha --> bool) --> ((alpha --> bool) --> bool)))),
      ("deleteX",
       (((alpha --> bool) --> ((alpha --> bool) --> (alpha --> bool))))),
      ("satisfy",(((alpha --> bool) --> (alpha --> bool)))),
      ("only",(((alpha --> bool) --> (alpha --> bool)))),
      ("delete",
       (((alpha --> bool) --> ((alpha --> bool) --> T"INSTR" "L0" [])))),
      ("insert",
       (((alpha --> bool) -->
         ((beta --> bool) -->
          ((alpha --> beta) -->
           ((alpha --> bool) --> T"INSTR" "L0" [])))))),
      ("insertX",
       (((beta --> bool) -->
         ((alpha --> bool) -->
          ((beta --> alpha) -->
           ((beta --> bool) --> (alpha --> bool))))))),
      ("ALLof",(((alpha --> bool) --> ((alpha --> bool) --> bool)))),
      ("update",
       (((alpha --> bool) -->
         ((alpha --> alpha) -->
          ((alpha --> bool) --> T"INSTR" "L0" []))))),
      ("drop",(((alpha --> bool) --> (alpha --> bool)))),
      ("select",
       (((beta --> bool) -->
         ((beta --> alpha) --> ((beta --> bool) --> (alpha --> bool)))))),
      ("updateX",
       (((alpha --> bool) -->
         ((alpha --> alpha) -->
          ((alpha --> bool) --> (alpha --> bool)))))),
      ("map",(((alpha --> beta) --> (alpha --> beta)))),
      ("ins",((alpha --> ((alpha --> bool) --> T"INSTR" "L0" [])))),
      ("del",((alpha --> ((alpha --> bool) --> T"INSTR" "L0" []))))];
  
  local
  val share_table = Vector.fromList
  [C"!" "bool" ((((alpha --> bool) --> bool) --> bool)),
   V"t" ((alpha --> bool)), V"p" ((alpha --> bool)),
   C"=" "min" (((alpha --> bool) --> ((alpha --> bool) --> bool))),
   C"deleteX" "lingu"
    (((alpha --> bool) --> ((alpha --> bool) --> (alpha --> bool)))),
   C"GSPEC" "pred_set"
    (((alpha --> T"prod" "pair" [alpha, bool]) --> (alpha --> bool))),
   V"r" (alpha),
   C"," "pair" ((alpha --> (bool --> T"prod" "pair" [alpha, bool]))),
   C"/\\" "bool" ((bool --> (bool --> bool))),
   C"IN" "bool" ((alpha --> ((alpha --> bool) --> bool))),
   C"~" "bool" ((bool --> bool)),
   C"!" "bool" ((((alpha --> alpha) --> bool) --> bool)),
   V"f" ((alpha --> alpha)),
   C"updateX" "lingu"
    (((alpha --> bool) -->
      ((alpha --> alpha) --> ((alpha --> bool) --> (alpha --> bool))))),
   C"COND" "bool" ((bool --> (alpha --> (alpha --> alpha)))),
   C"!" "bool" ((((beta --> bool) --> bool) --> bool)),
   V"t" ((beta --> bool)),
   C"!" "bool" ((((beta --> alpha) --> bool) --> bool)),
   V"f" ((beta --> alpha)), V"p" ((beta --> bool)),
   C"select" "lingu"
    (((beta --> bool) -->
      ((beta --> alpha) --> ((beta --> bool) --> (alpha --> bool))))),
   C"GSPEC" "pred_set"
    (((beta --> T"prod" "pair" [alpha, bool]) --> (alpha --> bool))),
   V"r" (beta), C"IN" "bool" ((beta --> ((beta --> bool) --> bool))),
   V"td" ((beta --> bool)),
   C"insertX" "lingu"
    (((beta --> bool) -->
      ((alpha --> bool) -->
       ((beta --> alpha) --> ((beta --> bool) --> (alpha --> bool)))))),
   C"UNION" "pred_set"
    (((alpha --> bool) --> ((alpha --> bool) --> (alpha --> bool)))),
   C"!" "bool" ((((alpha --> beta) --> bool) --> bool)),
   V"body" ((alpha --> beta)),
   C"=" "min" (((alpha --> beta) --> ((alpha --> beta) --> bool))),
   C"map" "lingu" (((alpha --> beta) --> (alpha --> beta))),
   V"body" ((alpha --> bool)),
   C"only" "lingu" (((alpha --> bool) --> (alpha --> bool))),
   C"drop" "lingu" (((alpha --> bool) --> (alpha --> bool))),
   C"satisfy" "lingu" (((alpha --> bool) --> (alpha --> bool))),
   C"!" "bool" (((alpha --> bool) --> bool)),
   C"=" "min" ((T"INSTR" "L0" [] --> (T"INSTR" "L0" [] --> bool))),
   C"ins" "lingu" ((alpha --> ((alpha --> bool) --> T"INSTR" "L0" []))),
   C"/:=" "L0"
    (((alpha --> bool) --> ((alpha --> bool) --> T"INSTR" "L0" []))),
   C"INSERT" "pred_set"
    ((alpha --> ((alpha --> bool) --> (alpha --> bool)))),
   V"td" ((alpha --> bool)), V"f" ((alpha --> beta)),
   C"insert" "lingu"
    (((alpha --> bool) -->
      ((beta --> bool) -->
       ((alpha --> beta) --> ((alpha --> bool) --> T"INSTR" "L0" []))))),
   C"/:=" "L0"
    (((beta --> bool) --> ((beta --> bool) --> T"INSTR" "L0" []))),
   C"insertX" "lingu"
    (((alpha --> bool) -->
      ((beta --> bool) -->
       ((alpha --> beta) --> ((alpha --> bool) --> (beta --> bool)))))),
   C"del" "lingu" ((alpha --> ((alpha --> bool) --> T"INSTR" "L0" []))),
   V"r'" (alpha), C"=" "min" ((alpha --> (alpha --> bool))),
   C"delete" "lingu"
    (((alpha --> bool) --> ((alpha --> bool) --> T"INSTR" "L0" []))),
   C"update" "lingu"
    (((alpha --> bool) -->
      ((alpha --> alpha) --> ((alpha --> bool) --> T"INSTR" "L0" [])))),
   C"=" "min" ((bool --> (bool --> bool))),
   C"ALLof" "lingu" (((alpha --> bool) --> ((alpha --> bool) --> bool))),
   C"==>" "min" ((bool --> (bool --> bool))),
   C"SOMEof" "lingu" (((alpha --> bool) --> ((alpha --> bool) --> bool))),
   C"?" "bool" (((alpha --> bool) --> bool)),
   C"\\/" "bool" ((bool --> (bool --> bool))), V"s" (alpha),
   V"q" ((alpha --> bool)),
   C"ALLof" "lingu" (((beta --> bool) --> ((beta --> bool) --> bool))),
   C"SOMEof" "lingu" (((beta --> bool) --> ((beta --> bool) --> bool))),
   C"?" "bool" (((beta --> bool) --> bool)), V"r'" (beta)]
  val DT = Thm.disk_thm share_table
  in
  val deleteX_def =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%3 ((%4 $1) $0)) (%5 (\%6. ((%7 $0) ((%8 ((%9
       $0) $2)) (%10 ($1 $0)))))))))))`)
  val updateX_def =
    DT("", [],
       `(%0 (\%1. (%11 (\%12. (%0 (\%2. ((%3 (((%13 $2) $1) $0)) (%5 (\%6.
       ((%7 (((%14 ($1 $0)) ($2 $0)) $0)) ((%9 $0) $3)))))))))))`)
  val select_def =
    DT("", [],
       `(%15 (\%16. (%17 (\%18. (%15 (\%19. ((%3 (((%20 $2) $1) $0)) (%21
       (\%22. ((%7 ($2 $0)) ((%8 ((%23 $0) $3)) ($1 $0))))))))))))`)
  val insertX_def =
    DT("", [],
       `(%15 (\%24. (%0 (\%1. (%17 (\%18. (%15 (\%19. ((%3 ((((%25 $3) $2)
       $1) $0)) ((%26 (%21 (\%22. ((%7 ($2 $0)) ((%8 ((%23 $0) $4)) ($1
       $0)))))) $2))))))))))`)
  val map_def = DT("", [], `(%27 (\%28. ((%29 (%30 $0)) $0)))`)
  val only_def = DT("", [], `(%0 (\%31. ((%3 (%32 $0)) $0)))`)
  val drop_def = DT("", [], `(%0 (\%31. ((%3 (%33 $0)) $0)))`)
  val satisfy_def = DT("", [], `(%0 (\%31. ((%3 (%34 $0)) $0)))`)
  val ins_def =
    DT("", [],
       `(%35 (\%6. (%0 (\%1. ((%36 ((%37 $1) $0)) ((%38 $0) ((%39 $1)
       $0)))))))`)
  val insert_def =
    DT("", [],
       `(%0 (\%40. (%15 (\%16. (%27 (\%41. (%0 (\%2. ((%36 ((((%42 $3) $2)
       $1) $0)) ((%43 $2) ((((%44 $3) $2) $1) $0)))))))))))`)
  val del_def =
    DT("", [],
       `(%35 (\%6. (%0 (\%1. ((%36 ((%45 $1) $0)) ((%38 $0) ((%4 $0) (%33
       (\%46. ((%47 $0) $2))))))))))`)
  val delete_def =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%36 ((%48 $1) $0)) ((%38 $1) ((%4 $1)
       $0)))))))`)
  val update_def =
    DT("", [],
       `(%0 (\%1. (%11 (\%12. (%0 (\%2. ((%36 (((%49 $2) $1) $0)) ((%38 $2)
       (((%13 $2) $1) $0)))))))))`)
  val ALLof_def =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%50 ((%51 $1) $0)) (%35 (\%6. ((%52 ((%9 $0)
       $2)) ($1 $0)))))))))`)
  val SOMEof_def =
    DT("", [],
       `(%0 (\%1. (%0 (\%2. ((%50 ((%53 $1) $0)) (%54 (\%6. ((%8 ((%9 $0)
       $2)) ($1 $0)))))))))`)
  val ALLof_ins_thm =
    DT("", [],
       `((%50 ((%51 ((%39 %6) %1)) %2)) ((%8 (%2 %6)) ((%51 %1) %2)))`)
  val SOMEof_ins_thm =
    DT("", [],
       `((%50 ((%53 ((%39 %6) %1)) %2)) ((%55 (%2 %6)) ((%53 %1) %2)))`)
  val IN_ins_thm =
    DT("", [],
       `((%50 ((%9 %56) ((%39 %6) %1))) ((%55 ((%47 %56) %6)) ((%9 %56)
       %1)))`)
  val ALLof_insert_thm =
    DT("", [],
       `((%50 ((%51 ((((%25 %24) %1) %18) %19)) %57)) ((%8 ((%58 %24)
       (\%22. ((%52 (%19 $0)) (%57 (%18 $0)))))) ((%51 %1) %57)))`)
  val SOMEof_insert_thm =
    DT("", [],
       `((%50 ((%53 ((((%25 %24) %1) %18) %19)) %57)) ((%55 ((%59 %24)
       (\%22. ((%8 (%19 $0)) (%57 (%18 $0)))))) ((%53 %1) %57)))`)
  val IN_insert_thm =
    DT("", [],
       `((%50 ((%9 %6) ((((%25 %24) %1) %18) %19))) ((%55 (%60 (\%61. ((%8
       (%19 $0)) ((%8 ((%23 $0) %24)) ((%47 %6) (%18 $0))))))) ((%9 %6)
       %1)))`)
  val ALLof_delete_thm =
    DT("", [],
       `((%50 ((%51 ((%4 %1) %2)) %57)) ((%51 %1) (\%6. ((%52 (%10 (%2
       $0))) (%57 $0)))))`)
  val SOMEof_delete_thm =
    DT("", [],
       `((%50 ((%53 ((%4 %1) %2)) %57)) ((%53 %1) (\%6. ((%8 (%10 (%2 $0)))
       (%57 $0)))))`)
  val IN_delete_thm =
    DT("", [],
       `((%50 ((%9 %6) ((%4 %1) %2))) ((%8 (%10 (%2 %6))) ((%9 %6) %1)))`)
  val ALLof_update_thm =
    DT("", [],
       `((%50 ((%51 (((%13 %1) %12) %2)) %57)) ((%51 %1) (\%6. ((%8 ((%52
       (%2 $0)) (%57 (%12 $0)))) ((%52 (%10 (%2 $0))) (%57 $0))))))`)
  val SOMEof_update_thm =
    DT("", [],
       `((%50 ((%53 (((%13 %1) %12) %2)) %57)) ((%53 %1) (\%6. ((%55 ((%8
       (%2 $0)) (%57 (%12 $0)))) ((%8 (%10 (%2 $0))) (%57 $0))))))`)
  val IN_update_thm =
    DT("", [],
       `((%50 ((%9 %6) (((%13 %1) %12) %2))) (%54 (\%46. ((%8 ((%9 $0) %1))
       ((%8 ((%52 (%2 $0)) ((%47 %6) (%12 $0)))) ((%52 (%10 (%2 $0))) ((%47
       %6) $0)))))))`)
  val ALLof_select_thm =
    DT("", [],
       `((%50 ((%51 (((%20 %16) %18) %19)) %57)) ((%58 %16) (\%22. ((%52
       (%19 $0)) (%57 (%18 $0))))))`)
  val SOMEof_select_thm =
    DT("", [],
       `((%50 ((%53 (((%20 %16) %18) %19)) %57)) ((%59 %16) (\%22. ((%8
       (%19 $0)) (%57 (%18 $0))))))`)
  val IN_select_thm =
    DT("", [],
       `((%50 ((%9 %6) (((%20 %16) %18) %19))) (%60 (\%61. ((%8 ((%23 $0)
       %16)) ((%8 (%19 $0)) ((%47 %6) (%18 $0)))))))`)
  end
  val _ = DB.bindl "lingu"
  [("deleteX_def",deleteX_def,DB.Def), ("updateX_def",updateX_def,DB.Def),
   ("select_def",select_def,DB.Def), ("insertX_def",insertX_def,DB.Def),
   ("map_def",map_def,DB.Def), ("only_def",only_def,DB.Def),
   ("drop_def",drop_def,DB.Def), ("satisfy_def",satisfy_def,DB.Def),
   ("ins_def",ins_def,DB.Def), ("insert_def",insert_def,DB.Def),
   ("del_def",del_def,DB.Def), ("delete_def",delete_def,DB.Def),
   ("update_def",update_def,DB.Def), ("ALLof_def",ALLof_def,DB.Def),
   ("SOMEof_def",SOMEof_def,DB.Def),
   ("ALLof_ins_thm",ALLof_ins_thm,DB.Thm),
   ("SOMEof_ins_thm",SOMEof_ins_thm,DB.Thm),
   ("IN_ins_thm",IN_ins_thm,DB.Thm),
   ("ALLof_insert_thm",ALLof_insert_thm,DB.Thm),
   ("SOMEof_insert_thm",SOMEof_insert_thm,DB.Thm),
   ("IN_insert_thm",IN_insert_thm,DB.Thm),
   ("ALLof_delete_thm",ALLof_delete_thm,DB.Thm),
   ("SOMEof_delete_thm",SOMEof_delete_thm,DB.Thm),
   ("IN_delete_thm",IN_delete_thm,DB.Thm),
   ("ALLof_update_thm",ALLof_update_thm,DB.Thm),
   ("SOMEof_update_thm",SOMEof_update_thm,DB.Thm),
   ("IN_update_thm",IN_update_thm,DB.Thm),
   ("ALLof_select_thm",ALLof_select_thm,DB.Thm),
   ("SOMEof_select_thm",SOMEof_select_thm,DB.Thm),
   ("IN_select_thm",IN_select_thm,DB.Thm)]
  
  local open Portable GrammarSpecials Parse
  in
  val _ = mk_local_grms [("pred_setTheory.pred_set_grammars",
                          pred_setTheory.pred_set_grammars),
                         ("L0Theory.L0_grammars",L0Theory.L0_grammars)]
  val _ = List.app (update_grms reveal) []
  val _ = update_grms
       (temp_overload_on_by_nametype "deleteX")
        {Name = "deleteX", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "updateX")
        {Name = "updateX", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "select")
        {Name = "select", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "insertX")
        {Name = "insertX", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "map")
        {Name = "map", Thy = "lingu"}
  val _ = update_grms temp_add_binder ("map", std_binder_precedence)
  val _ = update_grms
       (temp_overload_on_by_nametype "only")
        {Name = "only", Thy = "lingu"}
  val _ = update_grms temp_add_binder ("only", std_binder_precedence)
  val _ = update_grms
       (temp_overload_on_by_nametype "drop")
        {Name = "drop", Thy = "lingu"}
  val _ = update_grms temp_add_binder ("drop", std_binder_precedence)
  val _ = update_grms
       (temp_overload_on_by_nametype "satisfy")
        {Name = "satisfy", Thy = "lingu"}
  val _ = update_grms temp_add_binder ("satisfy", std_binder_precedence)
  val _ = update_grms
       (temp_overload_on_by_nametype "ins")
        {Name = "ins", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "insert")
        {Name = "insert", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "del")
        {Name = "del", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "delete")
        {Name = "delete", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "update")
        {Name = "update", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "ALLof")
        {Name = "ALLof", Thy = "lingu"}
  val _ = update_grms
       (temp_overload_on_by_nametype "SOMEof")
        {Name = "SOMEof", Thy = "lingu"}
  val lingu_grammars = Parse.current_lgrms()
  end
  
  
  val _ = computeLib.add_funs [deleteX_def];  
  
  val _ = computeLib.add_funs [updateX_def];  
  
  val _ = computeLib.add_funs [select_def];  
  
  val _ = computeLib.add_funs [insertX_def];  
  
  val _ = computeLib.add_funs [ins_def];  
  
  val _ = computeLib.add_funs [insert_def];  
  
  val _ = computeLib.add_funs [del_def];  
  
  val _ = computeLib.add_funs [delete_def];  
  
  val _ = computeLib.add_funs [update_def];  
  
  val _ = computeLib.add_funs [ALLof_def];  
  
  val _ = computeLib.add_funs [SOMEof_def];  
end
